#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h> 
#include <stdio.h>
#include "../../driver/slm.h"

#define BOOL	int
#define TRUE	1
#define FALSE	0

#define SLM "/dev/slm"

#define NFRAMES 1024;
void h_err(int);

#define ROW_SIZE (512)
#define IMAGE_LENGTH 512
#define SIZE 512*IMAGE_LENGTH
#define N 100000


main(int argc,char ** argv){

int index=1;
int* dummy=NULL;
float period;
BOOL set_period=FALSE;
int frame=0;
BOOL got_frame=FALSE;
BOOL verbose_mode=FALSE;

int	dev;
unsigned char image[SIZE];
int pos,y;
int n=0,err;

/*	printf("Steve's change_frame_bns program\n");*/

	if(argc==1){
		printf("Need some arguments!\n\n");
		printf("-fr  -frame       : frame to upload image to (REQUIRED)\n");
		printf("-t   -time_period : time period (not set by default)\n");
		printf("-v   -verbose     : confirm what's been done (not default)\n");
		exit(3);
		}

	while(index<argc){
		if(sc(argv[index],"-v")||sc(argv[index],"-verbose")){
			verbose_mode=TRUE;
			}
		if(sc(argv[index],"-t")||sc(argv[index],"-time_period")){
			sscanf(argv[++index],"%f",&period);
			set_period=TRUE;
			}
		if(sc(argv[index],"-fr")||sc(argv[index],"-frame")){
			sscanf(argv[++index],"%d",&frame);
			got_frame=TRUE;
			}
		index++;
		}

	if(got_frame==FALSE){
		printf("PROBLEM: You haven't specified a frame to display.\n That's kinda the whole point of this program. Use (eg) -fr 10\n");
		exit(1);
		}

	dev=open(SLM,O_RDWR);
	if(dev<0){
		printf("Failed to open %s\n",SLM);
		perror("slm_test:FTO:");
		exit(1);
		}

	if(set_period==TRUE){
		if(verbose_mode==TRUE){
			printf("Time period set to: %fs\n",period);
			}
		h_err(ioctl(dev,BNS_SET_PERIODS,(int)(period/164.4e-6)));
		}

	if(verbose_mode==TRUE){
		printf("Selecting frame %d\n",frame);
		}

	h_err(ioctl(dev,BNS_DISABLE_WRITE,dummy));
	h_err(ioctl(dev,BNS_DISPLAY_IMAGE,frame));
	}	
	
	
void h_err(int err){
	if(err!=0){
		printf("Got error %d\n",err);
		exit(1);
		}
	usleep(1000);
	}


BOOL sc(char *con,char *var){
	if(strcmp(con,var)==0){
		return TRUE;
		}
	return FALSE;
        }
