#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h> 
#include <stdio.h>
#include "slm.h"

#define IMAGE	"test_image/test_image.dat"
#define SLM "/dev/slm"
#define TIME	0x00000fff
#define 	QUIT		0
#define 	POWER_ON	1
#define 	POWER_OFF	2
#define 	ENABLE_WRITE	3
#define 	DISABLE_WRITE	4
#define 	UPLOAD_FRAME	5
#define 	HELP		10

void h_err(int);
#define CHUNK (512*64)
#define SIZE 512*512
#define N 100000
main(){
FILE	*fi;
int	dev;
unsigned char image[SIZE];
int pos,y,i,option;
int n=0,err;
char temp[1024];

	printf("Matt's test slm driver program\n");
	printf("Opening test image \"%s\"\n",IMAGE);
	fi=fopen(IMAGE,"r");
	if(fi==NULL){
		printf("Image %s not found\n",IMAGE);
		printf("Exiting\n");
		}
	printf("Reading data...");
	fread(image,sizeof(unsigned char),SIZE,fi);
	fclose(fi);
	printf("done\n");

	printf("Opening slm \"%s\"\n",SLM);
	dev=open(SLM,O_RDWR);
	if(dev<0){
		printf("Failed to open %s\n",SLM);
		perror("slm_test:FTO:");
		exit(1);
		}
	printf("periods to %x\n",TIME);
	h_err(ioctl(dev,BNS_SET_PERIODS,TIME));
	do{
		printf("Choose an optioni (help=%d):\n",HELP);
		scanf("%d",&option);
		switch(option){
			case HELP:
				printf("Power on	=%d\n",POWER_ON);
				printf("Power off	=%d\n",POWER_OFF);
				printf("Enable write	=%d\n",ENABLE_WRITE);
				printf("Disable write /\n Allow image	=%d\n",DISABLE_WRITE);
				printf("Upload frame	=%d\n",UPLOAD_FRAME);
				printf("Quit		=%d\n",QUIT);
				break;
			case POWER_ON:
				printf("Setting slm power on\n");
				h_err(ioctl(dev,BNS_POWER_ON,n));
				break;
			case POWER_OFF:
				printf("Setting slm power off\n");
				h_err(ioctl(dev,BNS_POWER_OFF,n));
				break;
			case ENABLE_WRITE:
				printf("Enabling write\n");
				h_err(ioctl(dev,BNS_ENABLE_WRITE,n));
				break;
			case DISABLE_WRITE:
				printf("Disabling write\n");
				h_err(ioctl(dev,BNS_DISABLE_WRITE,n));
				break;
			case UPLOAD_FRAME:
				printf("upload to %d \n",n);
				h_err(ioctl(dev,BNS_UPLOAD_IMAGE,n));
				for(pos=0,y=0;y<SIZE/CHUNK;y++,pos+=CHUNK){ 
					err=write(dev,image+pos,CHUNK);
					if(err!=CHUNK){
						printf("WRITE ERROR (writes enabled?)\n",err);
						break;
						}
					}
					printf("Done\n");
					break;
                        	}
			}	
		while(option!=QUIT);
	printf("Setting slm power off\n");
	h_err(ioctl(dev,BNS_POWER_OFF,n));
	printf("Done, exiting\n");
	}	
	
	
void h_err(int err){
	if(err!=0){
		printf("Got error %d\n",err);
		exit(1);
		}
	else{
		printf("Ok\n");
		}
	usleep(1000);
	}
